#!/usr/bin/env python
#
# Data Quality Checker also known as DQC
#
# Read the README.md for more detailed information
#
# Barcerlona Supercomputing Center - Centro Nacional de Supercomputacion
#        Earth Sciences Department - Computational Earth Sciences
#     
#     Authors: Ivan Jose Cernicharo Ortiz (ivan.cernicharo@bsc.es)
#             -
#             -
#

import sys
import logging
import os
import subprocess

class standard_compliance_test:

    def __init__(self,type=None,files):
        self.name = type
        self.files = files

    def cf_checker(args):
        from subprocess import Popen

        output = list()
        for ncfile in args:
            cmd0 = "cfchecks --version auto %s" %ncfile

            p0 = Popen(
                cmd0, shell=True,
                stdout=subprocess.PIPE,
                stderr=subprocess.STDOUT
                )

            out0, _ = p0.communicate()

            string = str(out0).replace('\'',"").replace("\"","").split('\\n')
            if any('ERROR:' in e for e in string):
                err = [item.split('ERROR:')[-1].strip() for item in string if item.startswith('ERROR:')]
                errstring = ncfile.split('/')[-1] + ' has ' + str(len(err))
                errstring += ' error messages' + '\n'
                errstring += '\n'.join(err)
                print(errstring)
                output.append(errstring)
            else:
                pass
            # We are only interested on errors but could be interesting for 
            # further versions of the dqc_checker to analyze the warnings 
            # and info messages
            # wrn = [item.split('WARN:')[-1].strip() for item in string if item.startswith('WARN:')]
            # inf = [item.split('INFO:')[-1].strip() for item in string if item.startswith('INFO:')]

    def grib_checker(args):
        # Have to import the grib_checker
        # import grib_checker

        output = list()
        for gribfile in args:
            # run grib_checker on each grib_file
            # output.append(errmessages)
            pass


    def main(self):
        if self.name != None:

            if self.name == "CF":
                cf_checker(self.files)

            if self.name == 'grib':
                grib_checker(self.files)

        else:
            sys.exit()

if __name__ == "__main__":
    sys.exit()