#!/usr/bin/env python
#
# Data Quality Checker also known as DQC
#
# Read the README.md for more detailed information
#
# Barcerlona Supercomputing Center - Centro Nacional de Supercomputacion
#        Earth Sciences Department - Computational Earth Sciences
#     
#     Authors: Ivan Jose Cernicharo Ortiz (ivan.cernicharo@bsc.es)
#             -
#             -
#

import sys
import logging
import os
import subprocess

class spatial_completeness_test:

    def __init__(self,type,files):
        self.type = type
        self.files = files

    def missing_values_netcdf(ncitem,e):
        var = ncitem.variables[e]
        variable = var[:]
        missing = variable.missing_value
        if var.mask == False:
            # If the variable does not have a mask
            datamiss = len(variable==missing)
            mk = False if len(datamiss) == 0 else True
        else:
            # If the variable does have a mask
            data_masked = variable.mask
            data = variable.data
            real_data = data[~data_masked]
            datamiss = len(real_data==missing)
            mk = False if len(datamiss) == 0 else True

        return datamiss,mk

    def netcdf_test(args):
        import netCDF4
        import numpy as np

        output = list()

        for ncfile in args:
            ncitem = netCDF4.Dataset(f)
            test_var = [item for item in ncitem.variables.keys() \
                if item not in ncitem.dimensions.keys()]
            if test_var != []:
                for e in test_var:
                    datamiss,mk = missing_values_netcdf(ncitem,e)
                    if mk == True:
                        string = ncfile.split('/')[-1] + ' variable '
                        string += e + ' has missing data ' + datamiss
                        output.append(string)

    def grib_test(args):

    def main(self):
        if self.type != None:

            if self.type == "CF":
                netcdf_test(self.files)

            if self.type == 'grib':
                grib_test(self.files)

        else:
            sys.exit()

if __name__ == "__main__":
    sys.exit()